package com.loafle.overflow.model.meta;

import java.util.HashMap;
import java.util.Map;

import javax.persistence.*;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "META_TARGET_HOST_TYPE", schema = "public")
@DiscriminatorValue("2")
public class MetaTargetHostType extends MetaTargetType {
  private static Map<String, Integer> mapping;

  public MetaTargetHostType(Integer id) {
    this.setId(id);
  }

  static {
    Map<String, Integer> mapping = new HashMap<>();
    mapping.put("UNKNOWN", 100);
    mapping.put("ALPINE_LINUX", 101);
    mapping.put("AMAZON_LINUX", 102);
    mapping.put("ANDROID", 103);
    mapping.put("CENTOS", 104);
    mapping.put("CISCO_IOS", 105);
    mapping.put("COREOS", 106);
    mapping.put("DARWIN", 107);
    mapping.put("DEBIAN", 108);
    mapping.put("FEDORA", 109);
    mapping.put("FREEBSD", 110);
    mapping.put("HP_UX", 111);
    mapping.put("IBM_AIX", 112);
    mapping.put("IBM_AS_400", 113);
    mapping.put("IBM_POWER8", 114);
    mapping.put("IOS", 115);
    mapping.put("LINUX", 116);
    mapping.put("MAC_OS_X", 117);
    mapping.put("MAC_OS_X_SERVE", 118);
    mapping.put("NETBSD", 119);
    mapping.put("NOVELL_NETWARE", 120);
    mapping.put("OPENBSD", 121);
    mapping.put("ORACLE_LINUX", 122);
    mapping.put("RASPBIAN", 123);
    mapping.put("RHEL", 124);
    mapping.put("SOLARIS", 125);
    mapping.put("SUSE", 126);
    mapping.put("UBUNTU", 127);
    mapping.put("UBUNTU_SERVER", 128);
    mapping.put("WINDOWS", 129);
    mapping.put("WINDOWS_SERVER", 130);

    MetaTargetHostType.mapping.putAll(mapping);
  }

  public static MetaTargetHostType toMetaTargetHostType(String key) {
    Integer id = MetaTargetHostType.mapping.get(key);
    if (null == id) {
      return null;
    }
    return new MetaTargetHostType(id);
  }
}
