package com.loafle.overflow.model.meta;

import java.util.HashMap;
import java.util.Map;

import javax.persistence.*;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "META_TARGET_SERVICE_TYPE", schema = "public")
@DiscriminatorValue("3")
public class MetaTargetServiceType extends MetaTargetType {
  private static Map<String, Integer> mapping;

  public MetaTargetServiceType(Integer id) {
    this.setId(id);
  }

  static {
    Map<String, Integer> mapping = new HashMap<>();
    mapping.put("UNKNOWN", 1000);
    mapping.put("ACTIVE_DIRECTORY", 1001);
    mapping.put("APACHE_HTTPD", 1002);
    mapping.put("CASSANDRA", 1003);
    mapping.put("COUCHBASE", 1004);
    mapping.put("COUCHDB", 1005);
    mapping.put("DB2", 1006);
    mapping.put("DHCP", 1007);
    mapping.put("DNS", 1008);
    mapping.put("EXCHANGE_SERVER", 1009);
    mapping.put("EXIM", 1010);
    mapping.put("FIREBIRD", 1011);
    mapping.put("FTP", 1012);
    mapping.put("GLASSFISH", 1013);
    mapping.put("HTTP", 1014);
    mapping.put("HTTPS", 1015);
    mapping.put("IMAP", 1016);
    mapping.put("INFLUXDB", 1017);
    mapping.put("INGRES", 1018);
    mapping.put("JBOSS", 1019);
    mapping.put("JMX", 1020);
    mapping.put("LDAP", 1021);
    mapping.put("LIGHTTPD", 1022);
    mapping.put("MARIADB", 1023);
    mapping.put("MEMCACHED", 1024);
    mapping.put("IIS", 1025);
    mapping.put("SQL_SERVER", 1026);
    mapping.put("MONGODB", 1027);
    mapping.put("MYSQL", 1028);
    mapping.put("NETBIOS", 1029);
    mapping.put("NGINX", 1030);
    mapping.put("NNTP", 1031);
    mapping.put("ORACLE", 1032);
    mapping.put("POP", 1033);
    mapping.put("POSTFIX", 1034);
    mapping.put("POSTGRESQL", 1035);
    mapping.put("REDIS", 1036);
    mapping.put("REDIS_SENTINEL", 1037);
    mapping.put("SENDMAIL", 1038);
    mapping.put("SMB", 1039);
    mapping.put("SMTP", 1040);
    mapping.put("SNMP", 1041);
    mapping.put("SNMP_V2", 1042);
    mapping.put("SNMP_V3", 1043);
    mapping.put("SQLITE", 1044);
    mapping.put("SQUID_CACHE", 1045);
    mapping.put("SQUID_PROXY", 1046);
    mapping.put("SSH", 1047);
    mapping.put("SYBASE", 1048);
    mapping.put("TELNET", 1049);
    mapping.put("TOMCAT", 1050);
    mapping.put("VARNISH", 1051);
    mapping.put("WEBSPHERE", 1052);
    mapping.put("WMI", 1053);
    mapping.put("ZIMBRA", 1054);

    MetaTargetServiceType.mapping.putAll(mapping);
  }

  public static MetaTargetServiceType toMetaTargetServiceType(String key) {
    Integer id = MetaTargetServiceType.mapping.get(key);
    if (null == id) {
      return null;
    }
    return new MetaTargetServiceType(id);
  }
}
